import numpy
import pandas as pd
import tensorflow as tf
from sklearn.model_selection import train_test_split

model = tf.keras.models.Sequential()

def trainModel(model, datasetFilePath):
    model.add(tf.keras.layers.Flatten())
    model.add(tf.keras.layers.Dense(256, activation=tf.nn.relu))
    model.add(tf.keras.layers.Dense(128, activation=tf.nn.relu))
    model.add(tf.keras.layers.Dense(46, activation=tf.nn.softmax))
    model.compile(optimizer='adam',
                  loss='sparse_categorical_crossentropy',
                  metrics=['accuracy'])
    model_df = pd.read_csv(datasetFilePath)
    X = model_df.values[:,0:15]
    y = model_df.values[:,15]
    print(y)
    x_train,x_test,y_train,y_test = train_test_split(X,y, stratify=y,test_size=0.2)

    x_train = tf.keras.utils.normalize(x_train, axis=1)
    x_test = tf.keras.utils.normalize(x_test, axis=1)
    model.fit(x_train, y_train, epochs=3)

    val_loss, val_acc = model.evaluate(x_test, y_test)
    print(val_loss)
    print(val_acc)

    model.save('model.h5')
    return model

def predict(model, data):
    return model.predict(numpy.array(data))

trainModel(model, "data.csv")
